;************************ lexluggers include file ****************************
;************* Copyright 1999 lexlugger, All rights reserved. ****************
;** Note: This file contains everything needed to create apps for the TI-89 **
;**       or TI-92+. It has been designed to work with the Plusshell        **
;**       development utilities. It has not been tested with the DoorsOS    **
;**       SDK. It has been developed using the Plusshell includes and the   **
;**       official TI exec.inc file. Use at own risk.                       **
;*****************************************************************************

;*****************************************************************************
;** Linker options - use xdef <option> the set them.                        **
;** Technically these are labels that can be made global by using xdef. The **
;** linker will then create the correct executable.                         **
;*****************************************************************************

_library:			;Create a library
_nostub:                        ;No program stub (no shell needed)
_ti89:				;Create TI-89 executable
_ti92:				;Create TI-92 executable
_ti92plus:			;Create TI-92+ executable


;*****************************************************************************
;** I/O ports                                                               **
;*****************************************************************************
IO_LINKSTATUS                      equ         $60000C
IO_LINKIO                          equ         $60000E
IO_VIDEOMEM                        equ         $600010
IO_VIDEOFREQUENCY                  equ         $600012
IO_TIMER                           equ         $600014
IO_KEYROWMASK                      equ         $600018
IO_KEYBOARDSTATUS                  equ         $60001A

;*****************************************************************************
;* DoorsOS RAM addresses                                                    **
;*****************************************************************************
lexos::CALCULATOR       equ     _RAM_CALL_000
lexos::LCD_WIDTH        equ     _RAM_CALL_001
lexos::LCD_HEIGHT       equ     _RAM_CALL_002
lexos::ROM_base         equ     _RAM_CALL_003
lexos::LCD_LINE_BYTES   equ     _RAM_CALL_004
lexos::KEY_LEFT         equ     _RAM_CALL_005
lexos::KEY_RIGHT        equ     _RAM_CALL_006
lexos::KEY_UP           equ     _RAM_CALL_007
lexos::KEY_DOWN         equ     _RAM_CALL_008
lexos::KEY_UPRIGHT      equ     _RAM_CALL_009
lexos::KEY_DOWNLEFT     equ     _RAM_CALL_00A
lexos::KEY_DIAMOND      equ     _RAM_CALL_00B
lexos::LCD_SIZE         equ     _RAM_CALL_00C
lexos::KEY_SHIFT        equ     _RAM_CALL_00D
lexos::font_medium      equ     _RAM_CALL_00E
lexos::ReturnValue      equ     _RAM_CALL_00F
lexos::kb_globals       equ     _RAM_CALL_010
lexos::Heap             equ     _RAM_CALL_011
lexos::FolderListHandle equ     _RAM_CALL_012
lexos::MainHandle       equ     _RAM_CALL_013
lexos::ROM_VERSION      equ     _RAM_CALL_014


;*****************************************************************************
;** System constants                                                        **
;*****************************************************************************

;Display buffer
LCD_DISPLAY                        equ         $4C00

;Jump table
JUMP_TABLE                         equ         200
JUMP_TABLE_SIZE                    equ         972                                

;*****************************************************************************
;** System calls use the C calling convention.                              **
;** WARNING!!!: Pointers are returned in a0, not d0!!!                      **
;*****************************************************************************
FirstWindow                        equ         0                                  
WinActivate                        equ         4                                  
WinAttr                            equ         8                                  
WinBackupToScr                     equ         12                                 
WinBackground                      equ         16                                 
WinBegin                           equ         20                                 
WinBitmapGet                       equ         24                                 
WinBitmapPut                       equ         28                                 
WinBitmapSize                      equ         32                                 
WinCharXY                          equ         36                                 
WinChar                            equ         40
WinClose                           equ         44
WinClr                             equ         48
WinDeactivate                      equ         52
WinDupStat                         equ         56
WinEllipse                         equ         60
WinFill                            equ         64
WinFillLines2                      equ         68
WinFillTriangle                    equ         72
WinFont                            equ         76
WinGetCursor                       equ         80
WinHide                            equ         84
WinHome                            equ         88
WinLine                            equ         92
WinLineNC                          equ         96
WinLineTo                          equ         100
WinLineRel                         equ         104
WinMoveCursor                      equ         108
WinMoveTo                          equ         112
WinMoveRel                         equ         116
WinOpen                            equ         120
WinPixGet                          equ         124
WinPixSet                          equ         128
WinRect                            equ         132
WinReOpen                          equ         136
WinScrollH                         equ         140
WinScrollV                         equ         144
WinStr                             equ         148
WinStrXY                           equ         152
DrawWinBorder                      equ         156
ScrRectDivide                      equ         160
RectWinToWin                       equ         164
RectWinToScr                       equ         168
UpdateWindows                      equ         172
MakeWinRect                        equ         176
ScrToWin                           equ         180
ScrToHome                          equ         184
ScrRect                            equ         188
Dialog                             equ         192
NoCallBack                         equ         196
DialogDo                           equ         200
DialogAdd                          equ         204
DialogNew                          equ         208
DrawStaticButton                   equ         212
MenuBegin                          equ         216
MenuCheck                          equ         220
MenuEnd                            equ         224
MenuKey                            equ         228
MenuOn                             equ         232
MenuPopup                          equ         236
MenuSubStat                        equ         240
MenuTopStat                        equ         244
MenuTopSelect                      equ         248
MenuTopRedef                       equ         252
MenuGetTopRedef                    equ         256
MenuAddText                        equ         260
MenuAddIcon                        equ         264
MenuNew                            equ         268
PopupAddText                       equ         272
PopupNew                           equ         276
PopupClear                         equ         280
PopupDo                            equ         284
PopupText                          equ         288
MenuUpdate                         equ         292
Parse2DExpr                        equ         296
Parse2DMultiExpr                   equ         300
Print2DExpr                        equ         304
Parms2D                            equ         308
display_statements                 equ         312
Parse1DExpr                        equ         316
pushkey                            equ         320
ngetchx                            equ         324
kbhit                              equ         328
sprintf                            equ         332
getcalc                            equ         336
sendcalc                           equ         340
LIO_Send                           equ         344
LIO_Get                            equ         348
LIO_Receive                        equ         352
LIO_GetMultiple                    equ         356
LIO_SendData                       equ         360
LIO_RecvData                       equ         364
SymAdd                             equ         368
SymAddMain                         equ         372
SymDel                             equ         376
HSymDel                            equ         380
SymFind                            equ         384
SymFindMain                        equ         388
SymFindHome                        equ         392
SymMove                            equ         396
FolderAdd                          equ         400
FolderCur                          equ         404
FolderDel                          equ         408
FolderFind                         equ         412
FolderGetCur                       equ         416
FolderOp                           equ         420
FolderRename                       equ         424
FolderCount                        equ         428
SymFindFirst                       equ         432
SymFindNext                        equ         436
SymFindPrev                        equ         440
SymFindFoldername                  equ         444
AddSymToFolder                     equ         448
FindSymInFolder                    equ         452
FolderCurTemp                      equ         456
FolderAddTemp                      equ         460
FolderDelTemp                      equ         464
FolderDelAllTemp                   equ         468
TempFolderName                     equ         472
IsMainFolderStr                    equ         476
ParseSymName                       equ         480
DerefSym                           equ         484
HSYMtoName                         equ         488
StrToTokN                          equ         492
TokToStrN                          equ         496
CheckGraphRef                      equ         500
ClearUserDef                       equ         504
CheckLinkLockFlag                  equ         508
TokenizeSymName                    equ         512
SymCmp                             equ         516
SymCpy                             equ         520
SymCpy0                            equ         524
ValidateSymName                    equ         528
VarRecall                          equ         532
VarStore                           equ         536
VarStoreLink                       equ         540
QSysProtected                      equ         544
CheckSysFunc                       equ         548
GetSysGraphRef                     equ         552
CheckReservedName                  equ         556
SymSysVar                          equ         560
ValidateStore                      equ         564
ResetSymFlags                      equ         568
HeapAvail                          equ         572
HeapAlloc                          equ         576
HeapAllocESTACK                    equ         580
HeapAllocHigh                      equ         584
HeapAllocThrow                     equ         588
HeapAllocHighThrow                 equ         592
HeapCompress                       equ         596
HeapDeref                          equ         600
HeapFree                           equ         604
HeapFreeIndir                      equ         608
HLock                              equ         612
HeapLock                           equ         616
HeapGetLock                        equ         620
HeapMax                            equ         624
HeapRealloc                        equ         628
HeapSize                           equ         632
HeapUnlock                         equ         636
HeapMoveHigh                       equ         640
HeapEnd                            equ         644
HeapAllocPtr                       equ         648
HeapFreePtr                        equ         652
NeedStack                          equ         656
TE_close                           equ         660
TE_checkSlack                      equ         664
TE_empty                           equ         668
TE_focus                           equ         672
TE_handleEvent                     equ         676
TE_indicateReadOnly                equ         680
TE_isBlank                         equ         684
TE_open                            equ         688
TE_openFixed                       equ         692
TE_pasteText                       equ         696
TE_reopen                          equ         700
TE_reopenPlain                     equ         704
TE_select                          equ         708
TE_shrinkWrap                      equ         712
TE_unfocus                         equ         716
TE_updateCommand                   equ         720
_bcd_math                          equ         724
bcdadd                             equ         728
bcdsub                             equ         732
bcdmul                             equ         736
bcddiv                             equ         740
bcdneg                             equ         744
bcdcmp                             equ         748
bcdlong                            equ         752
bcdbcd                             equ         756
EX_getArg                          equ         760
EX_getBCD                          equ         764
EX_stoBCD                          equ         768
CB_replaceTEXT                     equ         772
CB_fetchTEXT                       equ         776
CU_restore                         equ         780
CU_start                           equ         784
CU_stop                            equ         788
EV_captureEvents                   equ         792
EV_clearPasteString                equ         796
EV_getc                            equ         800
EV_getSplitRect                    equ         804
EV_notifySwitchGraph               equ         808
EV_paintOneWindow                  equ         812
EV_paintWindows                    equ         816
EV_restorePainting                 equ         820
EV_sendEvent                       equ         824
EV_sendEventSide                   equ         828
EV_sendString                      equ         832
EV_setCmdCheck                     equ         836
EV_setCmdState                     equ         840
EV_setFKeyState                    equ         844
EV_startApp                        equ         848
EV_startSide                       equ         852
EV_startTask                       equ         856
EV_suspendPainting                 equ         860
EV_switch                          equ         864
MO_currentOptions                  equ         868
MO_defaults                        equ         872
MO_digestOptions                   equ         876
MO_isMultigraphTask                equ         880
MO_modeDialog                      equ         884
MO_notifyModeChange                equ         888
MO_sendQuit                        equ         892
ST_angle                           equ         896
ST_batt                            equ         900
ST_busy                            equ         904
ST_eraseHelp                       equ         908
ST_folder                          equ         912
ST_graph                           equ         916
ST_helpMsg                         equ         920
ST_modKey                          equ         924
ST_precision                       equ         928
ST_readOnly                        equ         932
ST_stack                           equ         936
ST_refDsp                          equ         940
OSCheckBreak                       equ         944
OSClearBreak                       equ         948
OSEnableBreak                      equ         952
OSDisableBreak                     equ         956
OSRegisterTimer                    equ         960
OSFreeTimer                        equ         964
OSTimerCurVal                      equ         968
OSTimerExpired                     equ         972
OSTimerRestart                     equ         976
acos                               equ         980
asin                               equ         984
atan                               equ         988
atan2                              equ         992
cos                                equ         996
sin                                equ         1000
tan                                equ         1004
cosh                               equ         1008
sinh                               equ         1012
tanh                               equ         1016
exp                                equ         1020
log                                equ         1024
log10                              equ         1028
modf                               equ         1032
pow                                equ         1036
sqrt                               equ         1040
ceil                               equ         1044
fabs                               equ         1048
floor                              equ         1052
fmod                               equ         1056
top_estack                         equ         1060
next_expression_index              equ         1064
gr_active                          equ         1068
gr_other                           equ         1072
ABT_dialog                         equ         1076
HomeExecute                        equ         1080
HomePushEStack                     equ         1084
SP_Define                          equ         1088
store_data_var                     equ         1092
recall_data_var                    equ         1096
CharNumber                         equ         1100
spike_optionD                      equ         1104
spike_geo_titles                   equ         1108
spike_in_editor                    equ         1112
dv_create_graph_titles             equ         1116
spike_titles_in_editor             equ         1120
dv_findColumn                      equ         1124
spike_chk_gr_dirty                 equ         1128
GetStatValue                       equ         1132
partial_len                        equ         1136
paint_all_except                   equ         1140
EQU_select                         equ         1144
EQU_setStyle                       equ         1148
EQU_getNameInfo                    equ         1152
checkCurrent                       equ         1156
BN_power17Mod                      equ         1160
BN_powerMod                        equ         1164
BN_prodMod                         equ         1168
CAT_dialog                         equ         1172
caddcert                           equ         1176
cdecrypt                           equ         1180
ceof                               equ         1184
cfindcertfield                     equ         1188
cfindfield                         equ         1192
cgetc                              equ         1196
cgetcert                           equ         1200
cgetflen                           equ         1204
cgetfnl                            equ         1208
cgetnl                             equ         1212
cgetns                             equ         1216
cgetvernum                         equ         1220
copen                              equ         1224
copensub                           equ         1228
cputhdr                            equ         1232
cputnl                             equ         1236
cputns                             equ         1240
cread                              equ         1244
ctell                              equ         1248
cwrite                             equ         1252
cacos                              equ         1256
casin                              equ         1260
catan                              equ         1264
cacosh                             equ         1268
casinh                             equ         1272
catanh                             equ         1276
ccos                               equ         1280
csin                               equ         1284
ctan                               equ         1288
ccosh                              equ         1292
csinh                              equ         1296
ctanh                              equ         1300
csqrt                              equ         1304
cln                                equ         1308
clog10                             equ         1312
cexp                               equ         1316
CustomBegin                        equ         1320
CustomMenuItem                     equ         1324
CustomEnd                          equ         1328
ReallocExprStruct                  equ         1332
SearchExprStruct                   equ         1336
handleRclKey                       equ         1340
CustomFree                         equ         1344
ERD_dialog                         equ         1348
ERD_process                        equ         1352
ER_throwVar                        equ         1356
ER_catch                           equ         1360
ER_success                         equ         1364
EV_centralDispatcher               equ         1368
EV_defaultHandler                  equ         1372
EV_eventLoop                       equ         1376
EV_registerMenu                    equ         1380
EX_patch                           equ         1384
EM_abandon                         equ         1388
EM_blockErase                      equ         1392
EM_blockVerifyErase                equ         1396
EM_delete                          equ         1400
EM_findEmptySlot                   equ         1404
EM_GC                              equ         1408
EM_moveSymFromExtMem               equ         1412
EM_moveSymToExtMem                 equ         1416
EM_open                            equ         1420
EM_put                             equ         1424
EM_survey                          equ         1428
EM_twinSymFromExtMem               equ         1432
EM_write                           equ         1436
EM_writeToExtMem                   equ         1440
FL_addCert                         equ         1444
FL_download                        equ         1448
FL_getHardwareParmBlock            equ         1452
FL_getCert                         equ         1456
FL_getVerNum                       equ         1460
EQU_deStatus                       equ         1464
cmpstri                            equ         1468
fix_loop_displacements             equ         1472
FL_write                           equ         1476
fpisanint                          equ         1480
fpisodd                            equ         1484
round12                            equ         1488
round14                            equ         1492
GD_Circle                          equ         1496
GD_Line                            equ         1500
GD_HVLine                          equ         1504
GD_Pen                             equ         1508
GD_Eraser                          equ         1512
GD_Text                            equ         1516
GD_Select                          equ         1520
GD_Contour                         equ         1524
GKeyIn                             equ         1528
GKeyDown                           equ         1532
GKeyFlush                          equ         1536
HelpKeys                           equ         1540
QModeKey                           equ         1544
QSysKey                            equ         1548
WordInList                         equ         1552
BitmapGet                          equ         1556
BitmapInit                         equ         1560
BitmapPut                          equ         1564
BitmapSize                         equ         1568
ScrRectFill                        equ         1572
ScrRectOverlap                     equ         1576
ScrRectScroll                      equ         1580
ScrRectShift                       equ         1584
QScrRectOverlap                    equ         1588
FontGetSys                         equ         1592
FontSetSys                         equ         1596
FontCharWidth                      equ         1600
DrawClipChar                       equ         1604
DrawClipEllipse                    equ         1608
DrawClipLine                       equ         1612
DrawClipPix                        equ         1616
DrawClipRect                       equ         1620
DrawMultiLines                     equ         1624
DrawStrWidth                       equ         1628
FillTriangle                       equ         1632
FillLines2                         equ         1636
SetCurAttr                         equ         1640
SetCurClip                         equ         1644
LineTo                             equ         1648
MoveTo                             equ         1652
ScreenClear                        equ         1656
GetPix                             equ         1660
SaveScrState                       equ         1664
RestoreScrState                    equ         1668
PortSet                            equ         1672
PortRestore                        equ         1676
DrawChar                           equ         1680
DrawFkey                           equ         1684
DrawIcon                           equ         1688
DrawLine                           equ         1692
DrawPix                            equ         1696
DrawStr                            equ         1700
GM_Value                           equ         1704
GM_Intersect                       equ         1708
GM_Integrate                       equ         1712
GM_Inflection                      equ         1716
GM_TanLine                         equ         1720
GM_Math1                           equ         1724
GM_Derivative                      equ         1728
GM_DistArc                         equ         1732
GM_Shade                           equ         1736
YCvtFtoWin                         equ         1740
DlgMessage                         equ         1744
SetGraphMode                       equ         1748
Regraph                            equ         1752
GrAxes                             equ         1756
gr_xres_pixel                      equ         1760
CptFuncX                           equ         1764
XCvtPtoF                           equ         1768
YCvtPtoF                           equ         1772
YCvtFtoP                           equ         1776
XCvtFtoP                           equ         1780
GrLineFlt                          equ         1784
FuncLineFlt                        equ         1788
GrClipLine                         equ         1792
CptDeltax                          equ         1796
CptDeltay                          equ         1800
CkValidDelta                       equ         1804
GR_Pan                             equ         1808
FindFunc                           equ         1812
FindGrFunc                         equ         1816
grFuncName                         equ         1820
gr_initCondName                    equ         1824
CptIndep                           equ         1828
gr_CptIndepInc                     equ         1832
gr_del_locals                      equ         1836
gr_DelFolder                       equ         1840
gr_openFolder                      equ         1844
setup_more_graph_fun               equ         1848
unlock_more_graph_fun              equ         1852
execute_graph_func                 equ         1856
cpt_gr_fun                         equ         1860
cpt_gr_param                       equ         1864
cpt_gr_polar                       equ         1868
gr_execute_seq                     equ         1872
CountGrFunc                        equ         1876
FirstSeqPlot                       equ         1880
cleanup_seq_mem                    equ         1884
time_loop                          equ         1888
InitTimeSeq                        equ         1892
seqWebInit                         equ         1896
run_one_seq                        equ         1900
gr_seq_value                       equ         1904
StepCk                             equ         1908
seqStepCk                          equ         1912
rngLen                             equ         1916
gdb_len                            equ         1920
gdb_store                          equ         1924
gdb_recall                         equ         1928
gr_DispLabels                      equ         1932
GraphOrTableCmd                    equ         1936
ck_valid_float                     equ         1940
CreateEmptyList                    equ         1944
QSkipGraphErr                      equ         1948
gr_find_de_result                  equ         1952
InitDEAxesRng                      equ         1956
InitDEMem                          equ         1960
de_loop                            equ         1964
cleanup_de_mem                     equ         1968
gr_de_value                        equ         1972
gr_find_func_index                 equ         1976
CptLastIndepDE                     equ         1980
de_initRes                         equ         1984
gr_del_vars_in_folder              equ         1988
gr_de_axes_lbl                     equ         1992
gr_execute_de                      equ         1996
gr_delete_fldpic                   equ         2000
gr_remove_fldpic                   equ         2004
gr_add_fldpic                      equ         2008
gr_stopic                          equ         2012
gr_find_el                         equ         2016
deStepCk                           equ         2020
gr_ck_solvergraph                  equ         2024
GR3_addContours                    equ         2028
GraphActivate                      equ         2032
GR3_freeDB                         equ         2036
GR3_handleEvent                    equ         2040
GR3_paint3d                        equ         2044
GR3_xyToWindow                     equ         2048
GS_PlotTrace                       equ         2052
GS_PlotAll                         equ         2056
PlotDel                            equ         2060
PlotPut                            equ         2064
PlotGet                            equ         2068
PlotInit                           equ         2072
PlotDup                            equ         2076
PlotSize                           equ         2080
PlotLookup                         equ         2084
QActivePlots                       equ         2088
QPlotActive                        equ         2092
GT_BackupToScr                     equ         2096
GT_CalcDepVals                     equ         2100
GT_CenterGraphCursor               equ         2104
GT_CursorKey                       equ         2108
GT_DspFreeTraceCoords              equ         2112
GT_DspTraceCoords                  equ         2116
GT_DspMsg                          equ         2120
GT_Error                           equ         2124
GT_Format                          equ         2128
GT_FreeTrace                       equ         2132
GT_IncXY                           equ         2136
GT_KeyIn                           equ         2140
GT_QFloatCursorsInRange            equ         2144
GT_Regraph                         equ         2148
GT_Regraph_if_neccy                equ         2152
GT_Open                            equ         2156
GT_SaveAs                          equ         2160
GT_SelFunc                         equ         2164
GT_SetGraphRange                   equ         2168
GT_SetCursorXY                     equ         2172
GT_ShowMarkers                     equ         2176
GT_Trace                           equ         2180
GT_ValidGraphRanges                equ         2184
GT_WinBound                        equ         2188
GT_WinCursor                       equ         2192
GYcoord                            equ         2196
GXcoord                            equ         2200
round12_err                        equ         2204
GT_Set_Graph_Format                equ         2208
GT_PrintCursor                     equ         2212
GT_DE_Init_Conds                   equ         2216
GZ_Box                             equ         2220
GZ_Center                          equ         2224
GZ_Decimal                         equ         2228
GZ_Fit                             equ         2232
GZ_InOut                           equ         2236
GZ_Integer                         equ         2240
GZ_Previous                        equ         2244
GZ_Recall                          equ         2248
GZ_SetFactors                      equ         2252
GZ_Square                          equ         2256
GZ_Standard                        equ         2260
GZ_Stat                            equ         2264
GZ_Store                           equ         2268
GZ_Trig                            equ         2272
HeapGetHandle                      equ         2276
HeapPtrToHandle                    equ         2280
FreeHandles                        equ         2284
HS_chopFIFO                        equ         2288
HS_countFIFO                       equ         2292
HS_deleteFIFONode                  equ         2296
HS_freeAll                         equ         2300
HS_freeFIFONode                    equ         2304
HS_getAns                          equ         2308
HS_getEntry                        equ         2312
HS_getFIFONode                     equ         2316
HS_popEStack                       equ         2320
HS_newFIFONode                     equ         2324
HS_pushFIFONode                    equ         2328
HToESI                             equ         2332
OSInitKeyInitDelay                 equ         2336
OSInitBetweenKeyDelay              equ         2340
OSCheckSilentLink                  equ         2344
OSLinkCmd                          equ         2348
OSLinkReset                        equ         2352
OSLinkOpen                         equ         2356
OSLinkClose                        equ         2360
OSReadLinkBlock                    equ         2364
OSWriteLinkBlock                   equ         2368
OSLinkTxQueueInquire               equ         2372
OSLinkTxQueueActive                equ         2376
LIO_SendProduct                    equ         2380
MD5Init                            equ         2384
MD5Update                          equ         2388
MD5Final                           equ         2392
MD5Done                            equ         2396
convert_to_TI_92                   equ         2400
gen_version                        equ         2404
is_executable                      equ         2408
NG_RPNToText                       equ         2412
NG_approxESI                       equ         2416
NG_execute                         equ         2420
NG_graphESI                        equ         2424
NG_rationalESI                     equ         2428
NG_tokenize                        equ         2432
NG_setup_graph_fun                 equ         2436
NG_cleanup_graph_fun               equ         2440
push_END_TAG                       equ         2444
push_LIST_TAG                      equ         2448
tokenize_if_TI_92_or_text          equ         2452
setjmp                             equ         2456
longjmp                            equ         2460
VarGraphRefBitsClear               equ         2464
VarInit                            equ         2468
memcpy                             equ         2472
memmove                            equ         2476
strcpy                             equ         2480
strncpy                            equ         2484
strcat                             equ         2488
strncat                            equ         2492
memcmp                             equ         2496
strcmp                             equ         2500
strncmp                            equ         2504
memchr                             equ         2508
strchr                             equ         2512
strcspn                            equ         2516
strpbrk                            equ         2520
strrchr                            equ         2524
strspn                             equ         2528
strstr                             equ         2532
strtok                             equ         2536
_memset                            equ         2540
memset                             equ         2544
strerror                           equ         2548
strlen                             equ         2552
SymAddTwin                         equ         2556
SymDelTwin                         equ         2560
LoadSymFromFindHandle              equ         2564
MakeHsym                           equ         2568
SymFindPtr                         equ         2572
OSVRegisterTimer                   equ         2576
OSVFreeTimer                       equ         2580
sincos                             equ         2584
asinh                              equ         2588
acosh                              equ         2592
atanh                              equ         2596
itrig                              equ         2600
trig                               equ         2604
VarOpen                            equ         2608
VarSaveAs                          equ         2612
VarNew                             equ         2616
VarCreateFolderPopup               equ         2620
VarSaveTitle                       equ         2624
WinWidth                           equ         2628
WinHeight                          equ         2632
XR_stringPtr                       equ         2636
OSReset                            equ         2640
SumStoChkMem                       equ         2644
OSContrastUp                       equ         2648
OSContrastDn                       equ         2652
OSKeyScan                          equ         2656
OSGetStatKeys                      equ         2660
off                                equ         2664
idle                               equ         2668
OSSetSR                            equ         2672
AB_prodid                          equ         2676
AB_prodname                        equ         2680
AB_serno                           equ         2684
cgetcertrevno                      equ         2688
cgetsn                             equ         2692
de_rng_no_graph                    equ         2696
EV_hook                            equ         2700
_ds16u16                           equ         2704
_ms16u16                           equ         2708
_du16u16                           equ         2712
_mu16u16                           equ         2716
_ds32s32                           equ         2720
_ms32s32                           equ         2724
_du32u32                           equ         2728
_mu32u32                           equ         2732
assign_between                     equ         2736
did_push_var_val                   equ         2740
does_push_fetch                    equ         2744
delete_list_element                equ         2748
push_ans_entry                     equ         2752
index_after_match_endtag           equ         2756
push_indir_name                    equ         2760
push_user_func                     equ         2764
store_func_def                     equ         2768
store_to_subscripted_element       equ         2772
index_below_display_expression_aux equ         2776
get_key_ptr                        equ         2780
get_list_indices                   equ         2784
get_matrix_indices                 equ         2788
init_list_indices                  equ         2792
init_matrix_indices                equ         2796
push_float_qr_fact                 equ         2800
push_lu_fact                       equ         2804
push_symbolic_qr_fact              equ         2808
are_expressions_identical          equ         2812
compare_expressions                equ         2816
find_error_message                 equ         2820
check_estack_size                  equ         2824
delete_between                     equ         2828
deleted_between                    equ         2832
delete_expression                  equ         2836
deleted_expression                 equ         2840
estack_to_short                    equ         2844
estack_to_ushort                   equ         2848
factor_base_index                  equ         2852
factor_exponent_index              equ         2856
GetValue                           equ         2860
im_index                           equ         2864
index_numeric_term                 equ         2868
index_of_lead_base_of_lead_term    equ         2872
index_main_var                     equ         2876
is_advanced_tag                    equ         2880
is_antisymmetric                   equ         2884
is_complex_number                  equ         2888
is_complex0                        equ         2892
is_free_of_tag                     equ         2896
is_independent_of                  equ         2900
is_independent_of_de_seq_vars      equ         2904
is_independent_of_tail             equ         2908
is_independent_of_elements         equ         2912
is_monomial                        equ         2916
is_monomial_in_kernel              equ         2920
is_narrowly_independent_of         equ         2924
is_symmetric                       equ         2928
is_tail_independent_of             equ         2932
lead_base_index                    equ         2936
lead_exponent_index                equ         2940
lead_factor_index                  equ         2944
lead_term_index                    equ         2948
main_gen_var_index                 equ         2952
map_unary_over_comparison          equ         2956
min_quantum                        equ         2960
move_between_to_top                equ         2964
moved_between_to_top               equ         2968
numeric_factor_index               equ         2972
push_between                       equ         2976
push_expr_quantum                  equ         2980
push_expr2_quantum                 equ         2984
push_next_arb_int                  equ         2988
push_next_arb_real                 equ         2992
push_next_internal_var             equ         2996
push_quantum                       equ         3000
push_quantum_pair                  equ         3004
reductum_index                     equ         3008
remaining_factors_index            equ         3012
re_index                           equ         3016
reset_estack_size                  equ         3020
reset_control_flags                equ         3024
can_be_approxed                    equ         3028
compare_complex_magnitudes         equ         3032
compare_Floats                     equ         3036
did_push_cnvrt_Float_to_integer    equ         3040
estack_number_to_Float             equ         3044
float_class                        equ         3048
frexp10                            equ         3052
gcd_exact_whole_Floats             equ         3056
init_float                         equ         3060
is_Float_exact_whole_number        equ         3064
is_float_infinity                  equ         3068
is_float_negative_zero             equ         3072
is_float_positive_zero             equ         3076
is_float_signed_infinity           equ         3080
is_float_transfinite               equ         3084
is_float_unsigned_inf_or_nan       equ         3088
is_float_unsigned_zero             equ         3092
is_nan                             equ         3096
likely_approx_to_complex_number    equ         3100
likely_approx_to_number            equ         3104
norm1_complex_Float                equ         3108
push_Float                         equ         3112
push_Float_to_nonneg_int           equ         3116
push_Float_to_rat                  equ         3120
push_cnvrt_integer_if_whole_nmb    equ         3124
push_overflow_to_infinity          equ         3128
push_pow                           equ         3132
push_round_Float                   equ         3136
should_and_did_push_approx_arg2    equ         3140
signum_Float                       equ         3144
did_push_to_polar                  equ         3148
push_degrees                       equ         3152
push_format                        equ         3156
push_getkey                        equ         3160
push_getfold                       equ         3164
push_getmode                       equ         3168
push_gettype                       equ         3172
push_instring                      equ         3176
push_mrow_aux                      equ         3180
push_part                          equ         3184
push_pttest                        equ         3188
push_pxltest                       equ         3192
push_rand                          equ         3196
push_randpoly                      equ         3200
push_setfold                       equ         3204
push_setgraph                      equ         3208
push_setmode                       equ         3212
push_settable                      equ         3216
push_str_to_expr                   equ         3220
push_string                        equ         3224
push_switch                        equ         3228
push_to_cylin                      equ         3232
push_to_sphere                     equ         3236
cmd_andpic                         equ         3240
cmd_blddata                        equ         3244
cmd_circle                         equ         3248
cmd_clrdraw                        equ         3252
cmd_clrerr                         equ         3256
cmd_clrgraph                       equ         3260
cmd_clrhome                        equ         3264
cmd_clrio                          equ         3268
cmd_clrtable                       equ         3272
cmd_copyvar                        equ         3276
cmd_cubicreg                       equ         3280
cmd_custmoff                       equ         3284
cmd_custmon                        equ         3288
cmd_custom                         equ         3292
cmd_cycle                          equ         3296
cmd_cyclepic                       equ         3300
cmd_delfold                        equ         3304
cmd_delvar                         equ         3308
cmd_dialog                         equ         3312
cmd_disp                           equ         3316
cmd_dispg                          equ         3320
cmd_disphome                       equ         3324
cmd_disptbl                        equ         3328
cmd_drawfunc                       equ         3332
cmd_drawinv                        equ         3336
cmd_drawparm                       equ         3340
cmd_drawpol                        equ         3344
cmd_else                           equ         3348
cmd_endfor                         equ         3352
cmd_endloop                        equ         3356
cmd_endtry                         equ         3360
cmd_endwhile                       equ         3364
cmd_exit                           equ         3368
cmd_expreg                         equ         3372
cmd_fill                           equ         3376
cmd_fnoff                          equ         3380
cmd_fnon                           equ         3384
cmd_for                            equ         3388
cmd_get                            equ         3392
cmd_getcalc                        equ         3396
cmd_goto                           equ         3400
cmd_graph                          equ         3404
cmd_if                             equ         3408
cmd_ifthen                         equ         3412
cmd_input                          equ         3416
cmd_inputstr                       equ         3420
cmd_line                           equ         3424
cmd_linehorz                       equ         3428
cmd_linetan                        equ         3432
cmd_linevert                       equ         3436
cmd_linreg                         equ         3440
cmd_lnreg                          equ         3444
cmd_local                          equ         3448
cmd_lock                           equ         3452
cmd_logistic                       equ         3456
cmd_medmed                         equ         3460
cmd_movevar                        equ         3464
cmd_newdata                        equ         3468
cmd_newfold                        equ         3472
cmd_newpic                         equ         3476
cmd_newplot                        equ         3480
cmd_newprob                        equ         3484
cmd_onevar                         equ         3488
cmd_output                         equ         3492
cmd_passerr                        equ         3496
cmd_pause                          equ         3500
cmd_plotsoff                       equ         3504
cmd_plotson                        equ         3508
cmd_popup                          equ         3512
cmd_powerreg                       equ         3516
cmd_printobj                       equ         3520
cmd_prompt                         equ         3524
cmd_ptchg                          equ         3528
cmd_ptoff                          equ         3532
cmd_pton                           equ         3536
cmd_pttext                         equ         3540
cmd_pxlchg                         equ         3544
cmd_pxlcircle                      equ         3548
cmd_pxlhorz                        equ         3552
cmd_pxlline                        equ         3556
cmd_pxloff                         equ         3560
cmd_pxlon                          equ         3564
cmd_pxltext                        equ         3568
cmd_pxlvert                        equ         3572
cmd_quadreg                        equ         3576
cmd_quartreg                       equ         3580
cmd_randseed                       equ         3584
cmd_rclgdb                         equ         3588
cmd_rclpic                         equ         3592
cmd_rename                         equ         3596
cmd_request                        equ         3600
cmd_return                         equ         3604
cmd_rplcpic                        equ         3608
cmd_send                           equ         3612
cmd_sendcalc                       equ         3616
cmd_sendchat                       equ         3620
cmd_shade                          equ         3624
cmd_showstat                       equ         3628
cmd_sinreg                         equ         3632
cmd_slpline                        equ         3636
cmd_sorta                          equ         3640
cmd_sortd                          equ         3644
cmd_stogdb                         equ         3648
cmd_stopic                         equ         3652
cmd_style                          equ         3656
cmd_table                          equ         3660
cmd_text                           equ         3664
cmd_toolbar                        equ         3668
cmd_trace                          equ         3672
cmd_try                            equ         3676
cmd_twovar                         equ         3680
cmd_unlock                         equ         3684
cmd_while                          equ         3688
cmd_xorpic                         equ         3692
cmd_zoombox                        equ         3696
cmd_zoomdata                       equ         3700
cmd_zoomdec                        equ         3704
cmd_zoomfit                        equ         3708
cmd_zoomin                         equ         3712
cmd_zoomint                        equ         3716
cmd_zoomout                        equ         3720
cmd_zoomprev                       equ         3724
cmd_zoomrcl                        equ         3728
cmd_zoomsqr                        equ         3732
cmd_zoomstd                        equ         3736
cmd_zoomsto                        equ         3740
cmd_zoomtrig                       equ         3744
OSenqueue                          equ         3748
OSdequeue                          equ         3752
OSqinquire                         equ         3756
OSqhead                            equ         3760
OSqclear                           equ         3764
did_push_divide_units              equ         3768
has_unit_base                      equ         3772
init_unit_system                   equ         3776
is_units_term                      equ         3780
push_auto_units_conversion         equ         3784
push_unit_system_list              equ         3788
setup_unit_system                  equ         3792
all_tail                           equ         3796
any_tail                           equ         3800
is_matrix                          equ         3804
is_square_matrix                   equ         3808
is_valid_smap_aggregate            equ         3812
last_element_index                 equ         3816
map_tail                           equ         3820
map_tail_Int                       equ         3824
push_list_plus                     equ         3828
push_list_times                    equ         3832
push_reversed_tail                 equ         3836
push_sq_matrix_to_whole_number     equ         3840
push_transpose_aux                 equ         3844
push_zero_partial_column           equ         3848
remaining_element_count            equ         3852
push_offset_array                  equ         3856
push_matrix_product                equ         3860
is_pathname                        equ         3864
next_token                         equ         3868
nonblank                           equ         3872
push_parse_prgm_or_func_text       equ         3876
push_parse_text                    equ         3880
push_var                           equ         3884

;* lexlugger's _DEREF macro ********************************************
_LDEREF macro
        move.l  d0,-(a7)                ;create space for return value
        movem.l d0-d7/a0-a6,-(a7)       ;save regs
        move.w  \1,-(a7)                ;push handle onto stack
        move.l  JUMP_TABLE,a0           ;prepare HeapDeref()
        move.l  HeapDeref(a0),a0
        jsr     (a0)                    ;call HeapDeref()
        add.l   #2,a7                   ;restore stack
        move.l  a0,60(a7)               ;save return address
        movem.l (a7)+,d0-d7/a0-a6       ;restore regs
        move.l  (a7)+,\2                ;put result into destination
        endm

;** Lock a memory buffer *****************************************************
_LOCK   macro
        movem.l d0-d7/a0-a6,-(a7)       ;save regs
        move.w  \1,-(a7)                ;push handle onto stack
        move.l  JUMP_TABLE,a0           ;prepare HeapLock()
        move.l  HeapLock(a0),a0
        jsr     (a0)                    ;call HeapLock()
        add.l   #2,a7                   ;restore stack
        movem.l (a7)+,d0-d7/a0-a6       ;restore regs
        endm

;** Unlock a memory buffer ***************************************************
_UNLOCK macro
        movem.l d0-d7/a0-a6,-(a7)       ;save regs
        move.w  \1,-(a7)                ;push handle onto stack
        move.l  JUMP_TABLE,a0           ;prepare HeapUnlock()
        move.l  HeapUnlock(a0),a0
        jsr     (a0)                    ;call HeapUnlock()
        add.l   #2,a7                   ;restore stack
        movem.l (a7)+,d0-d7/a0-a6       ;restore regs
        endm

